
let tpi = 8. *. atan 1.


let gabor_coeff sigma lim t =
  let gb = exp (-.t *. t /. (sigma *. sigma)) /. (2. *. sqrt tpi *. sigma) in
  if gb >= lim then gb else 0.

(* wavelet変換による時間周波数解析 *)
let gabor x fs f =
  let nsmp = Array.length x in
  let a = 1. /. (float f) in
  let dft p =
    Array.init nsmp (fun n ->
      let t = (float (n-p)) /. (fs *. a) in
      let gb = gabor_coeff 1. 0.01 t in
      { Complex.re = x.(n) *. gb *. cos (tpi *. t); Complex.im = x.(n) *. gb *. sin (tpi *. t) }) |> Array.fold_left Complex.add Complex.zero
  in
  Array.init nsmp (fun p -> Complex.div (dft p) {Complex.re = 1. /. sqrt a; Complex.im = 1. /. sqrt a })

